// const testUrl = 'http://223.93.170.82:23650'
const testUrl = ''

export default {
  host: 'http://192.168.2.121:5050',
  // imgHost: 'http://192.168.2.121:82',      //富文本编辑器图片回传地址
  imgHost: 'http://192.168.2.241:82',      //富文本编辑器图片回传地址
  delayTime: 500,
  urls: {
    /* 登录注册相关接口 */
    'getImgVerification': '/api/user/userver/getImgVerification',
    'verifyImgVerification': '/api/user/userver/verifyImgVerification',
    'login': 'api/user/user/getJwt',
    'getSmsWithRegister': '/api/user/userver/getSmsWithRegister',
    // 'getSmsWithRegister': 'http://192.168.3.117:5050/api/user/userver/getSmsWithRegister',
    'verifySmsVerification': '/api/user/userver/verifySmsVerification',
    'checkTel': '/api/user/user/verifyNoUsername',//注册验证手机号
    'checkForgetTel': '/api/user/user/verifyExistUsername',//忘记密码验证手机号
    'registry': '/api/user/user/registry',
    'getSmsWithResetPassword': '/api/user/userver/getSmsWithResetPassword',
    'resetPassword': '/api/user/user/resetPassword',
    'getAccessdMenu': testUrl + '/api/user/user/getUserOrgMenu',  //获取左侧菜单项
    'getVersionInner': testUrl + 'api/knowledgeman/versionInfo/getVersionInfoInner',  //获取内部版本信息
    'getVersionOuter': 'api/knowledgeman/versionInfo/getVersionInfoOuter',  //获取外部版本信息
    'getUserEnumsData': '/api/user/getUserEnumsData',   //获取用户枚举数据
    'getDiagbotManEnumsData': '/api/diagbotman/getDiagbotManEnumsData',      //获取产品枚举类型
    'saveUserOper': '/api/diagbotman/optInfo/save',    //保存用户记录
    /* 朗通后台相关接口 */
    'getUserAuthenticationStatus': '/api/user/userAuthentication/getUserAuthenticationStatus',         //获取用户认证状态
    'getPersonInfo': '/api/user/user/getPersonInfo',
    'updatePersonInfo': '/api/user/user/updatePersonInfo',
    'midifyPassword': '/api/user/user/midifyPassword',
    'queryUserInfo': '/api/user/userInfo/queryUserInformation', //注册用户
    'exportUserInfo': '/api/user/report/exportUserInfo', //导出用户信息
    'exportKema': '/api/user/report/exportKema', //导出认证中用户
    'exportVerified': '/api/user/report/exportVerified', //导出已认证用户
    'renewalsInfos': '/api/diagbotman/userRenewals/renewalsInfos', // 续费列表
    'modifyOpeningTime': '/api/diagbotman/productOrder/modifyOpeningTime', //确定续费
    'deleteRenewalsInfos': '/api/diagbotman/userRenewals/cancelRenewalsInfos', //取消续费
    'getOrganizationInfo': '/api/user/userInfo/queryMechanismInformation',//获取机构信息
    'addOrganization': '/api/user/userInfo/addOrganization',//添加机构信息
    'modifineOrganization': '/api/user/userInfo/updateOrganizations',//修改机构信息
    'getuserAuthenticationInfo': '/api/user/userAuthentication/getuserAuthenticationInfo',
    'userAuthentication': '/api/user/userAuthentication/userAuthentication',   //用户认证
    'waitExamOrderCou': '/api/diagbotman/productOrder/waitExamOrderCou',
    'waitAuthen': '/api/user/userAuthentication/waitAuthen',
    'getAllProductOrder': '/api/diagbotman/productOrder/getAllProductOrder',  //获取产品线列表
    'queryAuthentication': '/api/user/userInfo/queryAuthentication',  //获取未认证超管信息列表
    'addUserInfo': '/api/user/userInfo/addUserInfo',    //添加超管
    'getOrgList': '/api/user/userInfo/findOrganization',      //获取未绑定超管的机构列表
    'exportProductOrderInfo': '/api/diagbotman/reporExcel/exportProductOrderInfo',  //导出产品线列表
    'exportAdminInfo': '/api/user/report/exportUserInfo',         //导出超管信息
    'auditUserInfoAll': '/api/user/userInfo/auditUserInfoAllNopass',     //超管审核不通过
    'auditUserInfoAllPass': '/api/user/userInfo/auditUserInfoAllPass',     //超管审核通过
    'getAuthenticated': '/api/user/userInfo/queryVerifiedUserOrganizationProduct',  //已认证超管信息    //获取已认证超管信息
    'getProductLinesManage': '/api/diagbotman/diagLantoneProduct/selectProduct',  //产品线管理列表,
    'delProductLine': '/api/diagbotman/diagLantoneProduct/deleteProduct',  //产品线删除
    'updateServiceStatus': '/api/diagbotman/diagLantoneProduct/updateServiceStatus',    //产品线启用停用
    'exportAuthedAdmin': '/api/user/report/exportVerified',   //导出已认证超管
    'delSuperAdmin': '/api/user/userInfo/updateDeleted',     //删除已认证超管
    'updateUserInfoAll': '/api/user/userInfo/updateUserInfo',  //修改超管
    'startAndendByuserId': '/api/diagbotman/productOrder/startAndendByuserId',    //已认证超管展开-启用停用
    'delInformationAvailable': '/api/diagbotman/productOrder/delInformationAvailable',   //已认证超管展开-删除
    'auditProductStatus': '/api/diagbotman/diagOrderDetails/auditStatus',   //产品线审核
    'addProductLine': '/api/diagbotman/diagLantoneProduct/addProducts',    //添加产品线
    'editProductLine': '/api/diagbotman/diagLantoneProduct/updateProduct',       //修改产品线
    'getProductDetail': '/api/diagbotman/diagLantoneProduct/opendedProduct',    //产品线详情
    'contineBuy': '/api/diagbotman/productOrder/modifyOpeningTime',    //已认证超管-续费
    'proDetails': '/api/diagbotman/diagOrderDetails/getAllOrderDetials',      //产品申请-详情
    /* 用户后台相关接口 */
    'getTrialProduct': '/api/diagbotman/morServices/showProductInfo',//更多服务
    'exportOrganizeInfo': '/api/user/report/exportOrganization',//导出机构信息
    'addOrder': '/api/diagbotman/morServices/addOrder',//立即开通
    'opendedProduct': '/api/diagbotman/diagLantoneProduct/opendedProductByCurrentUser',//已开通产品
    'getService': '/api/diagbotman/serviceInfo/getServiceListByCurrentUser',//获取已建立的服务端
    'addService': '/api/diagbotman/serviceInfo/createService',//添加服务端
    'manageService': '/api/diagbotman/serviceInfo/getServiceListPageByCurrentUser',//管理服务端
    'deleteService': '/api/diagbotman/serviceInfo/delService',//管理服务端-删除
    'createServiceToken': '/api/diagbotman/serviceToken/createServiceToken',//生成令牌
    'alreadyServiceToken': '/api/diagbotman/productService/getProductServiceByCurrentUser',//已生成令牌
    'delProductService': '/api/diagbotman/productService/deleteProductService',//已生成令牌-删除
    'detailProductService': '/api/diagbotman/serviceToken/getTokenByProductServiceId',//已生成令牌-查看
    'delServiceToken': '/api/diagbotman/serviceToken/deleteTokenByProductServiceId',//删除令牌
    'disableToken': '/api/diagbotman/serviceToken/disableToken',   //   禁用令牌
    'enableToken': '/api/diagbotman/serviceToken/enableToken',   //    启用令牌
    'getConsoleOnTrial': '/api/diagbotman/productOrder/getConsoleOnTrial', //可试用产品
    'openUpOnTrial': '/api/diagbotman/productOrder/openUpOnTrial', //  立即试用请求
    'productAuthProgress': '/api/diagbotman/productOrder/productAuthProgress', //产品开通进度
    'getConsoleOpened': '/api/diagbotman/productOrder/getConsoleOpened', // 控制台--已开通产品
    'enShowOption': '/api/diagbotman/productOrder/enShowOption', //控制台--是否显示选项
    'addRenewalsInfo': '/api/diagbotman/morServices/addRenewalsInfo', // 控制台--续费
    'getAuthenProgress': '/api/user/userAuthentication/queryAuthProgress', // 控制台--账号认证进度
    'intoVerify': '/api/diagbotman/productOrder/openProductCheck', // 控制台--进入验证
    /* 医学后台维护相关接口 */
    'getDropList': 'api/icssman/dictionaryInfo/getList', //下来选项列表（标签类型、标签归属等）
    'getTagList': 'api/icssman/questionInfo/list', //标签列表
    'searchTagList': 'api/icssman/questionInfo/index', //标签池检索
    'detailsTagList': 'api/icssman/questionInfo/getByIds', //根据多个标签ID返回标签内容
    'detailsTag': 'api/icssman/questionInfo/getById',      //根据标签ID返回标签内容
    'getDeptInfo': 'api/icssman/deptInfo/getDeptInfo', //科室维护
    'getDeptInfoDetials': 'api/icssman/deptInfo/getDeptInfoDetials', //科室维护-详情
    'deleteDeptInfo': 'api/icssman/deptInfo/deleteDeptInfo', //科室维护-删除
    'addDeptInfo': 'api/icssman/deptInfo/addDeptInfo', //科室维护-添加
    'modifDeptInfo': 'api/icssman/deptInfo/updateDeptInfo', //科室维护-修改
    'saveOrUpdate': 'api/icssman/questionInfo/saveOrUpdate', //添加标签保存
    'deleteTagGroup': 'api/icssman/questionInfo/delete', //删除标签组
    'getPromptList': 'api/icssman/introduceInfo/getIntroducePage',//提示信息列表
    'addPromptInfo': 'api/icssman/introduceInfo/saveIntroduce',//新增提示信息
    'delPromptInfo': 'api/icssman/introduceInfo/deleteRecord',//删除提示信息
    'PromptInfoDetail': 'api/icssman/introduceInfo/getIntroduceById',//提示信息详情
    'getIcssEnumsData': 'api/icssman/getIcssEnumsData',//icss枚举
    'similarName': 'api/icssman/retrieval/retrievalList', //别名维护
    'delSimilarName': 'api/icssman/retrieval/delRetrievalsByQuesId', //别名维护-删除
    'similarNameDetl': 'api/icssman/retrieval/getRetrievalsByTag', //别名维护-详情
    'addSimilarName': 'api/icssman/retrieval/addTagRetrieval', //别名维护-添加、修改
    // 'searchLable': 'api/icssman/questionInfo/index', //标签检索
    'searchLable': 'api/icssman/questionInfo/indexRev', //标签检索--过滤别名?
    'uploadFile': 'api/icssman/retrieval/retrievalExcelIm', //别名维护-导入
    'commonSymptomList': 'api/icssman/questionUsual/getDeptInfos', //常见症状维护-常见症状列表
    'getDepartmentList': 'api/icssman/questionUsual/getDeptName', //常见症状维护-科室列表
    'getSymptomList': 'api/icssman/questionUsual/getQuestionInfo', //常见科室症状维护--获取症状列表
    'addCommonSymptom': 'api/icssman/questionUsual/addQuestionUsual',  //常见科室症状维护--添加科室症状
    'getCommonSymptomById': 'api/icssman/questionUsual/getQuestionUsualByDept', //常见科室症状维护--修改、详情
    'delCommonSymptom': 'api/icssman/questionUsual/deleteQuestionUsual',  //常见科室症状维护--删除科室症状
    'discInformation': 'api/knowledgeman/disclaimerInformation/getDisclaimerInformations', //免责声明
    'addDiscInformation': 'api/knowledgeman/disclaimerInformation/addDisclaimerInformations', //免责声明-新增
    'modifDiscInformation': 'api/knowledgeman/disclaimerInformation/updateDisclaimerInformations', //免责声明-修改
    'delDiscInformation': 'api/knowledgeman/disclaimerInformation/cancelDisclaimerInformations', //免责声明-删除
    'closeInformation': 'api/knowledgeman/disclaimerInformation/endDisclaimerInformations', //免责声明-停用
    'openInformation': 'api/knowledgeman/disclaimerInformation/startDisclaimerInformations', //免责声明-启用
    'getQuestionInfos': 'api/icssman/moduleInfo/getQuestionInfos', //模板维护辅检标签池数据获取标准知识库
    'saveModuleInfo': 'api/icssman/moduleInfo/saveModuleInfo', //模板维护新增
    'updateModuleInfo': 'api/icssman/moduleInfo/updateModuleInfo', //模板维护修改
    'getModuleInfoList': 'api/icssman/moduleInfo/getModuleInfoList', //模板维护系统列表
    'getModuleInfoSub': 'api/icssman/moduleInfo/getModuleInfo', //获取子模板列表
    'getModuleInfoOne': 'api/icssman/moduleInfo/getModuleInfoOne', //模板维护系统修改获取单个模板信息上部分信息
    'getModuleDetailInfo': 'api/icssman/moduleInfo/getModuleDetailInfo', //模板维护系统修改获取单个模板右侧信息
    'delTemplate': 'api/icssman/moduleInfo/delete', //模板维护系统删除单个模板信息
    'getDeptShortListSearh': 'api/icssman/deptVital/getDeptShortList_Searh', //查体模板--科室下拉
    'getPhysicalExamTempList': 'api/icssman/deptVital/getDeptVitalPage', //查体模板列表
    'getPhysicalExamTempDepartList': 'api/icssman/deptVital/getDeptShortList_create', //查体模板科室列表--新增
    'getPhysicalExamTempByDepId': 'api/icssman/deptVital/getModuleByDeptId', //通过科室id获取查体模板
    'savePhysicalExamTemp': 'api/icssman/deptVital/saveDeptVitals',//保存查体模板
    'delPhysicalExamTemp': 'api/icssman/deptVital/delAllDeptVitalList',//删除查体模板
    'getConceptKnowledgeList': '/api/knowledgeman/conceptDetail/page', //  术语静态知识列表
    'getConceptKnowledge': '/api/knowledgeman/conceptDetail/getByConceptId',//术语静态知识详情
    'getConceptInfo': '/api/knowledgeman/concept/getConceptInfo', //  搜索术语
    // 'versionInfo': 'api/icssman/versionInfo/getVersionInfoAlls', //版本信息
    'versionInfo': 'api/knowledgeman/versionInfo/getVersionInfoAlls', //版本信息
    'addVersInfo': 'api/knowledgeman/versionInfo/saveVersionInfoAlls', //版本信息-添加
    'updateVersInfo': 'api/knowledgeman/versionInfo/updateVersionInfoAlls', //版本信息-修改
    'delVersionInfo': 'api/knowledgeman/versionDetail/cancelVersionDetails', //版本信息-删除版本说明
    'addVersionInfo': 'api/knowledgeman/versionDetail/addVersionDetails', //版本信息-添加版本说明
    'modiVersionInfo': 'api/knowledgeman/versionDetail/updateVersionDetails', //版本信息-修改版本说明
    'getVersionDetlInfo': 'api/knowledgeman/versionDetail/getDetailById', //版本信息-版本说明列表获取
    'promptServer': '/api/cdssman/file/uploadImage',    //静态知识富文本图片上传
    /**************医学术语维护****************/
    'getKnowledgeEnums': testUrl + '/api/knowledgeman/getKlmEnumsData', //术语库枚举
    'saveConceptInfo': '/api/knowledgeman/conceptDetail/insertOrUpdate',   //保存术语静态知识
    'delConceptInfo': '/api/knowledgeman/conceptDetail/delete',   //删除术语静态知识
    'knowledgeName': 'api/knowledgeman/concept/getAllInformation', //医学术语-命名维护
    'knowledgeUpload': 'api/knowledgeman/concept/conceptInfoExcelIm', //医学术语-命名维护-导入
    'allKnowledgeType': 'api/knowledgeman/lexicon/getAllLexicon', //医学术语-类型列表
    'deletMedicalName': 'api/knowledgeman/concept/removeConceptInfo', //医学术语-命名维护-删除
    'getMedicalDetail': 'api/knowledgeman/concept/getConceptInfoDetail', //医学术语-命名维护-详情
    'getSimilarList': 'api/knowledgeman/similar/getSimilarList', //医学术语-命名维护-相似词
    'addMedicalName': 'api/knowledgeman/concept/addConceptInfo', //医学术语-命名维护-添加修改
    'knowledgeRelation': 'api/knowledgeman/relation/getRelationInfoList', //医学术语-关系维护
    'delKnowledgeRelation': 'api/knowledgeman/relation/removeRelationInfo', //医学术语-关系维护-删除
    'getAllRelationType': 'api/knowledgeman/lexiconRelationship/getAllLexiconRelationship', //医学术语-关系维护-关系下拉
    'searchRelationConcept': 'api/knowledgeman/concept/getAllConcept', //医学术语-关系维护-搜索
    'addRelationConcept': 'api/knowledgeman/relation/addRelationInfo', //医学术语-关系维护-添加
    'RelationUpload': 'api/knowledgeman/relation/relationInfoExcelIm', //医学术语-关系维护-导入
    'scaleContentStructure': 'api/knowledgeman/scaleContent/page',  //量表结构维护 -- 列表
    'getAllDeptAndDisInfo': 'api/icssman/moduleInfo/getAllDeptAndDisInfo',  //模板维护-获取科室和疾病所有信息
    'queryEvaluationModulePages': 'api/icssman/evaluationModuleMapping/queryEvaluationModulePages',  //慢病管理评估维护 -- 列表
    'getMedicalInfoList': '/api/knowledgeman/medical/getMedicalInfoList', //医学术语--属性维护--属性列表
    'medicalInfoExcelIm': '/api/knowledgeman/medical/medicalInfoExcelIm', //医学术语--属性维护-术语医学属性excel文件导入
    'getMedicalInfoDetail': '/api/knowledgeman/medical/getMedicalInfoDetail', //医学术语--属性维护--属性详情
    'addMedicalInfo': '/api/knowledgeman/medical/addMedicalInfo', //医学术语--属性维护--术语医学属性添加或者编辑
    'removeMedicalInfo': '/api/knowledgeman/medical/removeMedicalInfo', //医学术语--属性维护--术语医学属性删除
    'getAllLexiconRelationship': '/api/knowledgeman/lexicon/getAllLexicon', //医学术语--获取所有关系类型
    'getAllConcept': '/api/knowledgeman/conceptDetail/index',   //医学术语--获取所有概念（标准术语）
    'getAllBodypart': '/api/knowledgeman/bodypart/getAllBodypart',  //医学术语--获取所有部位
    'getAllDepts': '/api/knowledgeman/medical/getAllDepts',  //医学术语--获取所有科室
    'getLisMappingPage': '/api/knowledgeman/lisMapping/getLisMappingPage', //医学数据-化验大小项与公表项维护-列表
    'saveLisMapping': '/api/knowledgeman/lisMapping/saveLisMapping',  //医学数据-化验大小项与公表项维护-新增
    'delLisMappingById': '/api/knowledgeman/lisMapping/delLisMappingById',  //医学数据-化验大小项与公表项维护-单个删除
    'delLisMappingByIds': '/api/icssman/lisMapping/delLisMappingByIds', //医学数据-化验大小项与公表项维护-批量删除
    'modifyLisMapping': '/api/icssman/lisMapping/modifyLisMapping',  //医学数据-化验大小项与公表项维护-修改
    'hasLisMapping': '/api/knowledgeman/lisMapping/hasLisMapping',  //医学数据-化验大小项与公表项维护-化验公表项映射是否已存在
    'getTypeList': 'api/knowledgeman/lexicon/getLexiconList', //术语类型-列表
    'addType': 'api/knowledgeman/lexicon/addLexicon', //术语类型-添加
    'getAllLisConcept': 'api/knowledgeman/concept/getAllLisConcept',  //医学数据-化验大小项与公表项维护-获取所有化验公表项
    'queryIndexConfigPages': 'api/knowledgeman/indexConfig/queryIndexConfigPages',  //医学数据-慢病指标值关联维护-列表
    'getIndexConfigLists': 'api/knowledgeman/indexConfig/getIndexConfigLists',  //医学数据-慢病指标值关联维护-获取慢病指标值关联
    'cancelIndexConfigAlls': 'api/knowledgeman/indexConfig/cancelIndexConfigAlls',  //医学数据-慢病指标值关联维护-删除慢病指标值关联
    'saveIndexConfigLists': 'api/knowledgeman/indexConfig/saveIndexConfigLists',  //医学数据-慢病指标值关联维护-添加关联
    'updateIndexConfigList': 'api/knowledgeman/indexConfig/updateIndexConfigList',  //医学数据-慢病指标值关联维护-修改关联
    'queryIndexConfigDiseaseNames': 'api/knowledgeman/indexConfig/queryIndexConfigDiseaseNames',  //医学数据-慢病指标值关联维护-慢病指标疾病标签查询
    'getDisScaleAllInfo': 'api/icssman/disScale/getDisScaleAllInfo',  //医学数据-诊断量表关联维护-列表
    'addDisScaleInfo': 'api/icssman/disScale/addDisScaleInfo',  //医学数据-诊断量表关联维护-添加和修改
    'getDisScaleByDisId': 'api/icssman/disScale/getDisScaleByDisId',  //医学数据-诊断量表关联维护-根据诊断id获取诊断量表关联信息(修改回读用)
    'delDisScaleInfo': 'api/icssman/disScale/delDisScaleInfo',  //医学数据-诊断量表关联维护-删除
    'insertOrUpdate': 'api/knowledgeman/scaleContent/insertOrUpdate',  //量表结构维护 -- 添加或者更新
    'rebuildOrUpdate': 'api/knowledgeman/scaleContent/getByConceptId',  //量表结构维护 -- 添加或者更新
    'deleteScale': 'api/knowledgeman/scaleContent/delete',  //量表结构维护 -- 删除
    'searchKnowledgeLis': 'api/knowledgeman/scaleContent/index', //量表结构检索
    'getknowledgeList': 'api/knowledgeman/dictionaryInfo/getList', //量表结构字典信息
    'getModuleType': 'api/icssman/moduleInfo/getModuleType',  //模板维护 -- 类型筛选
    'indexByLexicon': testUrl + '/' + 'api/icssman/questionInfo/indexByLexicon',  //知识库标准化-根据名称和术语库词性类型搜索
    'indexByLexiconStandWord': 'api/knowledgeman/commonconcept/indexByLexicon',  //知识库标准化-根据名称搜索
    'getAssaySon': 'api/knowledgeman/lisSonContact/lisSonContactList',  //化验子项维护
    'getAssaySonDetail': 'api/knowledgeman/lisSonContact/relationContactDetail',  //化验子项维护-详情
    'getConceptInfoAssay': '/api/knowledgeman/concept/getAllForRelation',  //化验子项维护-搜索术语
    'addAssaySon': 'api/knowledgeman/lisSonContact/addRelation',  //化验子项维护-添加
    'delAssaySon': 'api/knowledgeman/lisSonContact/removeRelationContact',  //化验子项维护-删除/恢复
    'getConceptRelation': 'api/knowledgeman/relationContact/relationContactList',  //术语关联维护
    'getConceptRelationDet': 'api/knowledgeman/relationContact/relationContactDetail',  //术语关联维护-详情
    'addConceptRelation': 'api/knowledgeman/relationContact/addRelation',  //术语关联维护-添加
    'delConceptRelation': 'api/knowledgeman/relationContact/removeRelationContact',  //术语关联维护-删除/恢复
    'multContactList': 'api/knowledgeman/multContact/multContactList', //知识库标准化-医学术语多层关联维护-列表
    'removeRelationContact': 'api/knowledgeman/multContact/removeRelationContact', //知识库标准化-医学术语多层关联维护-删除或者恢复
    'relationContactDetail': 'api/knowledgeman/multContact/relationContactDetail', //知识库标准化-医学术语多层关联维护-详情
    'addMultRelation': 'api/knowledgeman/multContact/addRelation', //知识库标准化-医学术语多层关联维护-添加或者编辑
    'reloadLib': 'api/knowledgeman/reload/createFile', //术语命名-加载词库
    'getDeptList': '/api/knowledgeman/concept/getConceptListByType', //术语命名-诊断-科室
    'assistCheckMultContactList': '/api/knowledgeman/pacsMultContact/multContactList',   //医学术语维护-辅检层级维护列表
    'assistCheckAddMultRelation': '/api/knowledgeman/pacsMultContact/addRelation',   //医学术语维护-辅检层级维护-添加关联
    'assistCheckMultRelationDetail': '/api/knowledgeman/pacsMultContact/relationContactDetail',   //医学术语维护-辅检层级维护-详情
    'assistCheckRemoveMultRelation': '/api/knowledgeman/pacsMultContact/removeRelationContact',   //医学术语维护-辅检层级维护-删除或恢复
    'assistCheckPacsSonContactList': '/api/knowledgeman/pacsSonContact/pacsSonContactList', //医学术语维护-辅检子项维护列表
    'assistCheckPacsAddPacsRelation': '/api/knowledgeman/pacsSonContact/addPacsRelation', //医学术语维护-辅检子项维护-添加或编辑
    'assistCheckGetPacsContactDetail': '/api/knowledgeman/pacsSonContact/getPacsContactDetail', //医学术语维护-辅检子项维护-详情
    'assistCheckRemoveRelationPacs': '/api/knowledgeman/pacsSonContact/removeRelationPacs', //医学术语维护-辅检子项维护-删除或恢复


    /*********预问诊相关接口**********/
    'questionList': testUrl + '/api/precman/questionInfo_prec/page',     //预问诊-填写单列表
    'questionAdd': testUrl + '/api/precman/questionInfo_prec/saveOrUpdate',      //预问诊-填写单添加
    'questionSearch': testUrl + '/api/precman/questionInfo_prec/index',    //预问诊-填写单检索
    'preTypeList': testUrl + '/api/precman/dictionaryInfo_prec/getList',   //类型枚举
    'questionDel': '/api/precman/questionInfo_prec/delete',      //删除
    'uploadImg': '/api/precman/file_prec/uploadImage',       //图片上传
    'fileDel': '/api/precman/file_prec/deleteRemoteFile',          //图片删除
    'questionDetail': testUrl + '/api/precman/questionInfo_prec/getById',                //填写单详情
    'moduleList': testUrl + '/api/precman/moduleInfo_prec/getModuleInfoList',        //模板列表
    'addModule': '/api/precman/moduleInfo_prec/saveOrUpdateModuleInfo',        //模板添加
    'delModule': '/api/precman/moduleInfo_prec/delete',        //模板删除
    'moduleDetail': '/api/precman/moduleInfo_prec/getModuleInfoOne',    //模板详情
    'deptList': testUrl + '/api/precman/moduleInfo_prec/getAllDeptAndDisInfo',    //模板-科室列表
    'getPrecModuleType': testUrl + '/api/precman/moduleInfo_prec/getModuleType',     //获取未创建的模板类型
    'getByIds': '/api/prec/questionInfo/getByIds',// 获取多个问题
    'getBySubQuestionId': testUrl + '/api/precman/questionInfo_prec/getBySubQuestionId',// 获取是否被关联
    /*********诊断依据*********/
    'exportDiagnosticAll': '/api/knowledgeman/diagnose/exportDiagnosticAll', //诊断依据--导出诊断依据
    'exportDiagnosticBasis': '/api/knowledgeman/diagnose/exportDiagnosticBasis', //诊断依据--导出诊断依据问题
    'importDiagnosticBasis': '/api/knowledgeman/diagnose/importDiagnosticBasis', //诊断依据--导入诊断依据数据
    'queryQuestionPage': '/api/knowledgeman/diagnoseQuestion/queryQuestionPage', //诊断依据--问题词分页查询
    'diagBaseDelete': '/api/knowledgeman/diagnose/delete', //诊断依据--删除
    'diagBaseGetDetail': '/api/knowledgeman/diagnose/getDetail', //诊断依据--获取详情
    'diagBaseIndex': '/api/knowledgeman/diagnose/index', //诊断依据--诊断检索
    'diagBasePage': testUrl + '/api/knowledgeman/diagnose/page', //诊断依据--分页
    'diagBaseUpdateNeo': '/api/knowledgeman/diagnose/updateNeo', //诊断依据--更新图谱
    'diagBaseVerifyAllData': '/api/knowledgeman/diagnose/verifyAllData', //诊断依据--校验所有数据
    'diagBaseVerifyData': '/api/knowledgeman/diagnose/verifyData', //诊断依据--校验数据
    'tempSaveOrUpate': '/api/knowledgeman/diagnose/tempSaveOrUpate', //诊断依据-临时保存
    'diagBaseSearch': '/api/knowledgeman/diagnose/search', //诊断依据-搜索标准词或者关联词
    'getUniqueNameWithList': '/api/knowledgeman/lisMapping/getUniqueNameWithList', //医学数据-查找化验公表名
    /*********数据统计  *********/
    'statisticsCount': '/api/bi/statistics/count', //诊断依据--校验数据
    /*********安全管理  *********/
    'tokenList': '/api/mrqcman/mrqcToken/list',  // 令牌列表
    'tokenSaveOrUpdate': '/api/mrqcman/mrqcToken/saveOrUpdate', // 令牌新增或修改
    'tokenDetails': '/api/mrqcman/mrqcToken/getById', // 令牌明细
    'tokenDelete': '/api/mrqcman/mrqcToken/delete', // 令牌删除
    'tokenAnalysis': '/api/mrqcman/mrqcToken/analysis', //解析
    'rulesList': '/api/knowledgeman/rulePub/pageRulePub',
    'ruleDetail': '/api/knowledgeman/rulePub/getRulePub',
    'ruleApplyDetail': '/api/knowledgeman/ruleApp/getRuleApp',
    'rulesApplyList': '/api/knowledgeman/ruleApp/pageRuleApp',
    'addRule': '/api/knowledgeman/rulePub/saveRulePub',
    'ruleTypesList': '/api/knowledgeman/rulePub/pageRulePub',
    'addRuleApply': '/api/knowledgeman/ruleApp/saveRuleApp',
    'ruleApplyDelete': '/api/knowledgeman/ruleApp/removeRuleApp',
    'ruleDelete': '/api/knowledgeman/rulePub/removeRulePub',

    'getRecord': '/api/mrman/arRechome/getAllList',//病历管理
    'getRecordDetail': '/api/mrman/arRechome/getBABLContent',//病历管理--病历详情
    'saveRecord': '/api/mrman/arRechome/saveBABLContent',  //保存病例
    'getTypes': '/api/mrman/getMrEnumsData',//枚举类型
    'getFieldList': testUrl + "/api/mrman/qc/qcQuestionInfo/page",    //获取字段映射列表
    'getFieldDetail': '/api/mrman/qc/qcQuestionInfo/getById',//获取标签详情
    'addFieldMatch': "/api/mrman/qc/qcQuestionInfo/saveOrUpdate",    //添加字段映射
    'getQcTypes': testUrl + "/api/mrman/qc/dictionaryInfo/getList",    //添加字段映射
    'delFieldMatch': "/api/mrman/qc/qcQuestionInfo/delete",    //删除字段映射  
    'getQCTemplist': testUrl + '/api/mrman/qc/qcModuleInfo/page', // 获取模板列表
    'saveOrUpdateQCTemp': '/api/mrman/qc/qcModuleInfo/saveOrUpdateModuleInfo', //新增或修改模板
    'delQCTemp': '/api/mrman/qc/qcModuleInfo/delete', //删除模板
    'getQCTempDetail': testUrl + '/api/mrman/qc/qcModuleInfo/getById', //获取模板详情
    'getQCName': '/api/mrman/qc/qcQuestionInfo/index', //获取字段名称
    'getQcFlawList': '/api/mrman/qcCasesEntry/indexCaseEntry',   //获取缺陷列表
    'getModuleTypeList': '/api/mrman/qc/qcModuleInfo/index', //获取模块类型列表
    'getRecordInpList': '/api/mrman/qcInputcases/getAllInputcases',//获取全部病历录入
    'removeRecordInpById': '/api/mrman/qcInputcases/cancelById',//删除病历录入
    'addRecordInp': '/api/mrman/qcInputcases/saveOrUpdata', //保存和修改全部病历录入 
    'getRecordInpModule': '/api/mrman/qcCases/getAll', //获取全部模块及条目
    'getRecordInpModuleByHospital': '/api/mrman/qcCases/getAllByHospital', //获取全部模块及条目根据医院名称
    'getRecordHopitalList': '/api/mrman/qcHospitalInfo/getHospitalInfoAll',//获取医院信息 
    'getRecordCases': testUrl + '/api/mrman/qcCases/getCases', //获取全部模块
    'getRecordIremList': testUrl + '/api/mrman/qcCasesEntry/getAll', //获取病例条目列表
    'addRecordItem': '/api/mrman/casesEntryHospital/insertByHospital', //添加病例条目
    'getRecordByHospital': '/api/mrman/casesEntryHospital/getAllByHospital', //获取指定医院的病例条目 
    'updateRecordByHospital': '/api/mrman/casesEntryHospital/updateByHospital', //更新指定医院的病例条目 
    'delRecordItem': '/api/mrman/qcCasesEntry/deleteQcCasesEntry', //删除病例条目
    'getRecordItemDetail': '/api/mrman/qcCasesEntry/getUpdateInfo', //获取病例详情
    'getInputcasesDetial': '/api/mrman/qcInputcases/getInputcasesDetial', //获取标注病例详情
    'gethospitalModuleList': '/api/mrman/qcMode/getModes', //获取医院数据模块
    'getQcTypeList': testUrl + '/api/mrman/qc/qcType/page', //获取质控类型列表
    'addQcType': testUrl + '/api/mrman/qc/qcType/saveOrUpdate', //新增质控类型
    'delQcType': '/api/mrman/qc/qcType/delete', //删除质控类型
    'getQcTypeItem': testUrl + '/api/mrman/qc/qcType/getEntryByHospital', //获取质控条目
    'getQcTypeDetail': testUrl + '/api/mrman/qc/qcType/getById', //获取质控类型明细
    'getQcEntryTypeList': testUrl + '/api/mrman/qc/qcEntryType/page', //质控条目与质控类型关系--分页列表
    'getQcEntryTypeDetail': testUrl + '/api/mrman/qc/qcEntryType/getById', //质控条目与质控类型关系--根据entryId和医院id返回内容
    'getQcEntryTypeByHospital': testUrl + '/api/mrman/qc/qcEntryType/getTypeByHospital', //质控条目与质控类型关系--根据医院获取质控类型列表
    'getQcEntryTypeIndex': testUrl + '/api/mrman/qc/qcEntryType/index', //质控条目与质控类型关系--根据医院和条目检索未被选择的质控类型
    'ifNeedUnbind': testUrl + '/api/mrman/qc/qcType/getOrCancel',   //判断质控类型是否已被绑定、解除绑定
    'qcTypeList': testUrl + '/api/mrman/qc/qcType/indexData',    //其他质控类型列表
    'saveQcEntryType': '/api/mrman/qc/qcEntryType/saveOrUpdate', //质控条目与质控类型关系--保存
    'getStdList': '/api/mrman/stdBehospitalInfo/getSthospitalInfoPage',//标准病例列表
    'delStdRecord': '/api/mrman/stdBehospitalInfo/clearSthospitalInfo',//删除标准病例
    'updateStdRecord': '/api/mrman/stdBehospitalInfo/updataSthospitalInfo',//更新标准病例
    'findStdRecord': '/api/mrman/stdBehospitalInfo/findSthospitalInfo',//查找标准病例
    'getStdDeptList': '/api/mrman/medBehospitalInfo/findhospitalDept', //获取科室列表
    'getTestItems': '/api/mrman/stdBehospitalInfo/getStatistic',     //获取病例条目统计
    'addTask': '/api/mrman/stdMissionDetail/addMissionDetail',   //添加任务
    'getTaskList': '/api/mrman/stdMissionInfo/getMissionInfoPage',   //获取任务列表
    'delTask': '/api/mrman/stdMissionInfo/clearMissionInfo',   //获取任务列表
    'editTask': '/api/mrman/stdMissionInfo/getMissionInfoPage',   //获取任务列表
    'getTaskDetailList': '/api/mrman/stdMissionDetail/getMissionDetailPage',   //获取任务详情列表
    'getTaskDetail': '/api/mrman/stdMissionDetail/getMissionDetailPage',   //获取单个任务详情
    'editTaskDetail': '/api/mrman/stdMissionDetail/updateMissionDetail',   //任务详情修改
    'delTaskDetail': '/api/mrman/stdMissionDetail/clearMissionDetail',     //任务详情删除
    'autoTest': '/api/mrman/stdBehospitalInfo/analyze',  //自动化测试
    'saveDefaultModuleInfo': '/api/mrman/qc/qcModuleInfo/saveDefaultModuleInfo',  //模板列表首页
    'ControModuleInfo': '/api/mrman/qc/qcType/ControModuleInfo',  //指控类型列表首页



    // 'promptServer': '/sys/file/uploadImage',    //静态知识富文本图片上传
    // 'midifyPassword': '/sys/user/midifyPassword',    //修改密码
    'delConceptInfoCDSS': '/api/cdssman/graph/conceptInfo/changeStatus',   //静态知识启用禁用
    'getConceptKnowledgeListCDSS': '/api/cdssman/graph/conceptInfo/getPage', //  术语静态知识列表
    'getConceptKnowledgeCDSS': '/api/cdssman/graph/conceptInfo/getRecordById',//术语静态知识详情
    'isExistCDSS': '/api/cdssman/graph/conceptInfo/isExist',// 静态知识是否存在
    'saveConceptInfoCDSS': '/api/cdssman/graph/conceptInfo/saveOrUpdateRecord',   //保存术语静态知识
    'getAllConceptCDSS': '/api/cdssman/graph/conceptInfo/staticKnowledgeIndexWithoutInfo',   //医学术语检索-新增静态知识
    // 'delLisMappingByIdCDSS': '/api/knowledgeman/lisMapping/delLisMappingById',  //医学数据-化验大小项与公表项维护-单个删除
    // 'getConceptInfoAssayCDSS': '/api/knowledgeman/concept/getAllForRelation',  //化验子项维护-搜索术语
    // 'getAllLisConceptCDSS': 'api/knowledgeman/concept/getAllLisConcept',  //医学数据-化验大小项与公表项维护-获取所有化验公表项
    // 'hasLisMappingCDSS': '/api/knowledgeman/lisMapping/hasLisMapping',  //医学数据-化验大小项与公表项维护-化验公表项映射是否已存在


    'getMappingListPageCDSS': '/api/cdssman/hospitalInfo/getMappingListPage',  //获取术语映射统计列表

    'retrievalSearchCDSS': '/api/cdssman/demo/retrieval/index',   //术语检索
    'getLisMappingPageCDSS': '/api/cdssman/tran/diseaseConfig/getPage', //诊断列表
    'diseaseIsExistRecordCDSS': '/api/cdssman/tran/diseaseConfig/isExistRecord',   //诊断-映射关系是否已存在
    'saveOrUpdateDiseaseRecordCDSS': '/api/cdssman/tran/diseaseConfig/saveOrUpdateRecord',   //诊断-保存或修改映射关系
    'deleteDiseaseRecordCDSS': '/api/cdssman/tran/diseaseConfig/deleteRecord',   //诊断-删除映射关系
    'exportDiseaseRecordCDSS': '/api/cdssman/tran/diseaseConfig/exportExcel',   //诊断-数据导出
    'importDiseaseRecordCDSS': '/api/cdssman/tran/diseaseConfig/importExcel',   //诊断-数据导入
    'exportDiseaseModuleCDSS': '/api/cdssman/tran/diseaseConfig/exportExcelModule',
    'precDiseaseDataMatch': '/api/cdssman/tran/diseaseConfig/precDataMatch',
    'dataDiseaseVerify': '/api/cdssman/tran/diseaseConfig/dataVerify',

    'getLisPageCDSS': '/api/cdssman/tran/lisConfig/getPage',   //检验列表
    'lisIsExistRecordCDSS': '/api/cdssman/tran/lisConfig/isExistRecord',   //检验-映射关系是否已存在
    'saveOrUpdateLisRecordCDSS': '/api/cdssman/tran/lisConfig/saveOrUpdateRecord',   //检验-保存或修改映射关系
    'deleteLisRecordCDSS': '/api/cdssman/tran/lisConfig/deleteRecord',   //检验-删除映射关系
    'exportLisRecordCDSS': '/api/cdssman/tran/lisConfig/exportExcel',   //检验-数据导出
    'importLisRecordCDSS': '/api/cdssman/tran/lisConfig/importExcel',   //检验-数据导入
    'exportLisModuleCDSS': '/api/cdssman/tran/lisConfig/exportExcelModule',
    'precLisDataMatch': '/api/cdssman/tran/lisConfig/precDataMatch',
    'dataLisVerify': '/api/cdssman/tran/lisConfig/dataVerify',

    'getpacsPageCDSS': '/api/cdssman/tran/pacsConfig/getPage',   //检查列表
    'pacsIsExistRecordCDSS': '/api/cdssman/tran/pacsConfig/isExistRecord',   //检查-映射关系是否已存在
    'saveOrUpdatePacsRecordCDSS': '/api/cdssman/tran/pacsConfig/saveOrUpdateRecord',   //检查-保存或修改映射关系
    'deletePacsRecordCDSS': '/api/cdssman/tran/pacsConfig/deleteRecord',   //检查-删除映射关系
    'exportPacsRecordCDSS': '/api/cdssman/tran/pacsConfig/exportExcel',   //检查-数据导出
    'importPacsRecordCDSS': '/api/cdssman/tran/pacsConfig/importExcel',   //检查-数据导入
    'exportPacsModuleCDSS': '/api/cdssman/tran/pacsConfig/exportExcelModule',
    'precPacsDataMatch': '/api/cdssman/tran/pacsConfig/precDataMatch',
    'dataPacsVerify': '/api/cdssman/tran/pacsConfig/dataVerify',

    'getDrugPageCDSS': '/api/cdssman/tran/drugConfig/getPage',   //药品列表
    'drugIsExistRecordCDSS': '/api/cdssman/tran/drugConfig/isExistRecord',   //药品-映射关系是否已存在
    'saveOrUpdateDrugRecordCDSS': '/api/cdssman/tran/drugConfig/saveOrUpdateRecord',   //药品-保存或修改映射关系
    'deleteDrugRecordCDSS': '/api/cdssman/tran/drugConfig/deleteRecord',   //药品-删除映射关系
    'exportDrugRecordCDSS': '/api/cdssman/tran/drugConfig/exportExcel',   //药品-数据导出
    'importDrugRecordCDSS': '/api/cdssman/tran/drugConfig/importExcel',   //药品-数据导入
    'exportDrugModuleCDSS': '/api/cdssman/tran/drugConfig/exportExcelModule',
    'precDrugDataMatch': '/api/cdssman/tran/drugConfig/precDataMatch',
    'dataDrugVerify': '/api/cdssman/tran/drugConfig/dataVerify',

    'getScalePageCDSS': '/api/cdssman/tran/scaleConfig/getPage',   //量表列表
    'scaleIsExistRecordCDSS': '/api/cdssman/tran/scaleConfig/isExistRecord',   //量表-映射关系是否已存在
    'saveOrUpdateScaleRecordCDSS': '/api/cdssman/tran/scaleConfig/saveOrUpdateRecord',   //量表-保存或修改映射关系
    'deleteScaleRecordCDSS': '/api/cdssman/tran/scaleConfig/deleteRecord',   //量表-删除映射关系
    'exportScaleRecordCDSS': '/api/cdssman/tran/scaleConfig/exportExcel',   //量表-数据导出
    'importScaleRecordCDSS': '/api/cdssman/tran/scaleConfig/importExcel',   //量表-数据导入
    'exportScaleModuleCDSS': '/api/cdssman/tran/scaleConfig/exportExcelModule',
    'precScaleDataMatch': '/api/cdssman/tran/scaleConfig/precDataMatch',
    'dataScaleVerify': '/api/cdssman/tran/scaleConfig/dataVerify',

    'getOperationPageCDSS': '/api/cdssman/tran/operationConfig/getPage',   //手术/操作列表
    'operationIsExistRecordCDSS': '/api/cdssman/tran/operationConfig/isExistRecord',   //手术/操作-映射关系是否已存在
    'saveOrUpdateOperationRecordCDSS': '/api/cdssman/tran/operationConfig/saveOrUpdateRecord',   //手术/操作-保存或修改映射关系
    'deleteOperationRecordCDSS': '/api/cdssman/tran/operationConfig/deleteRecord',   //手术/操作-删除映射关系
    'exportOperationRecordCDSS': '/api/cdssman/tran/operationConfig/exportExcel',   //手术/操作-数据导出
    'importOperationRecordCDSS': '/api/cdssman/tran/operationConfig/importExcel',   //手术/操作-数据导入
    'exportOperationModuleCDSS': '/api/cdssman/tran/operationConfig/exportExcelModule',
    'precOperationDataMatch': '/api/cdssman/tran/operationConfig/precDataMatch',
    'dataOperationVerify': '/api/cdssman/tran/operationConfig/dataVerify',

    'getFusionPageCDSS': '/api/cdssman/tran/transfusionConfig/getPage',   //输血列表
    'fusionIsExistRecordCDSS': '/api/cdssman/tran/transfusionConfig/isExistRecord',   //输血-映射关系是否已存在
    'saveOrUpdateFusionRecordCDSS': '/api/cdssman/tran/transfusionConfig/saveOrUpdateRecord',   //输血-保存或修改映射关系
    'deleteFusionRecordCDSS': '/api/cdssman/tran/transfusionConfig/deleteRecord',   //输血-删除映射关系
    'exportFusionRecordCDSS': '/api/cdssman/tran/transfusionConfig/exportExcel',   //输血-数据导出
    'importFusionRecordCDSS': '/api/cdssman/tran/transfusionConfig/importExcel',   //输血-数据导入
    'exportFusionModuleCDSS': '/api/cdssman/tran/transfusionConfig/exportExcelModule',
    'precFusionDataMatch': '/api/cdssman/tran/transfusionConfig/precDataMatch',
    'dataFusionVerify': '/api/cdssman/tran/transfusionConfig/dataVerify',

    'getDeptPageCDSS': '/api/cdssman/tran/deptConfig/getPage',   //科室列表
    'deptIsExistRecordCDSS': '/api/cdssman/tran/deptConfig/isExistRecord',   //科室-映射关系是否已存在
    'saveOrUpdateDeptRecordCDSS': '/api/cdssman/tran/deptConfig/saveOrUpdateRecord',   //科室-保存或修改映射关系
    'deleteDeptRecordCDSS': '/api/cdssman/tran/deptConfig/deleteRecord',   //科室-删除映射关系
    'exportDeptRecordCDSS': '/api/cdssman/tran/deptConfig/exportExcel',   //科室-数据导出
    'importDeptRecordCDSS': '/api/cdssman/tran/deptConfig/importExcel',   //科室-数据导入
    'exportDeptModuleCDSS': '/api/cdssman/tran/deptConfig/exportExcelModule',   //科室-数据导入模板导出
    'precDeptDataMatch': '/api/cdssman/tran/deptConfig/precDataMatch',
    'dataDeptVerify': '/api/cdssman/tran/deptConfig/dataVerify',

    'getNursePage': '/api/cdssman/tran/nurseConfig/getPage',   //护理列表
    'nurseIsExistRecord': '/api/cdssman/tran/nurseConfig/isExistRecord',   //护理-映射关系是否已存在
    'saveOrUpdateRecord': '/api/cdssman/tran/nurseConfig/saveOrUpdateRecord',   //护理列表添加
    'deleteNurseRecord': '/api/cdssman/tran/nurseConfig/deleteRecord',   //护理-删除映射关系
    'exportNurseRecord': '/api/cdssman/tran/nurseConfig/exportExcel',   //护理-数据导出
    'importNurseRecord': '/api/cdssman/tran/nurseConfig/importExcel',   //检验-数据导入
    'exportNurseModule': '/api/cdssman/tran/nurseConfig/exportExcelModule',   //护理-数据导入模板导出
    'precNurseDataMatch': '/api/cdssman/tran/nurseConfig/precDataMatch',
    'dataNurseVerify': '/api/cdssman/tran/nurseConfig/dataVerify',


    'getTcmdiseasePage': '/api/cdssman/tran/tcmdiseaseConfig/getPage',   //中医疾病列表
    'tcmIsExistRecord': '/api/cdssman/tran/tcmdiseaseConfig/isExistRecord',   //中医疾病-映射关系是否已存在
    'saveOrUpdateRecordTcm': '/api/cdssman//tran/tcmdiseaseConfig/saveOrUpdateRecord',   //护理列表添加
    'deleteTcmRecord': '/api/cdssman/tran/tcmdiseaseConfig/deleteRecord',   //中医疾病-删除映射关系
    'exportTcmRecord': '/api/cdssman/tran/tcmdiseaseConfig/exportExcel',   //中医疾病-数据导出
    'importTcmRecord': '/api/cdssman/tran/tcmdiseaseConfig/importExcel',   //检验-数据导入
    'exportTcmModule': '/api/cdssman/tran/tcmdiseaseConfig/exportExcelModule',   //护理-数据导入模板导出
    'precTcmDataMatch': '/api/cdssman/tran/tcmdiseaseConfig/precDataMatch',
    'dataTcmVerify': '/api/cdssman/tran/tcmdiseaseConfig/dataVerify',

    'getTcmsyndromePage': '/api/cdssman/tran/tcmsyndromeConfig/getPage',   //中医证候列表
    'tcmdromeIsExistRecord': '/api/cdssman/tran/tcmsyndromeConfig/isExistRecord',   //中医证候-映射关系是否已存在
    'saveOrUpdateRecordTcmdrome': '/api/cdssman//tran/tcmsyndromeConfig/saveOrUpdateRecord',   //中医证候列表添加
    'deleteTcmdromeRecord': '/api/cdssman/tran/tcmsyndromeConfig/deleteRecord', 
    'exportTcmdromeRecord': '/api/cdssman/tran/tcmsyndromeConfig/exportExcel',   //中医证候-数据导出
    'importTcmdromeRecord': '/api/cdssman/tran/tcmsyndromeConfig/importExcel',   //中医证候-数据导入
    'exportTcmdromeModule': '/api/cdssman/tran/tcmsyndromeConfig/exportExcelModule',   //中医证候-数据导入模板导出
    'precTcmdromeDataMatch': '/api/cdssman/tran/tcmsyndromeConfig/precDataMatch',
    'dataTcmdromeVerify': '/api/cdssman/tran/tcmsyndromeConfig/dataVerify',


    // 'saveHospitalInfoRecordCDSS': '/api/cdssman/tran/hospitalInfo/saveRecord',   //医院信息——修改医院信息

    'modifyConnectStatusCDSS': '/api/cdssman/hospitalInfo/modifyConnectStatus',   //医院信息——修改医院信息 
    'changeStatusCDSS': '/api/cdssman/hospitalInfo/changeStatus',   //医院信息——启用禁用
    'getHospitalPageCDSS': '/api/cdssman/hospitalInfo/getPage',   //医院信息——分页查询
    'saveOrUpdateHosRecordCDSS': '/api/cdssman/hospitalInfo/saveOrUpdateRecord',   //医院信息——保存或修改映射关系
    'deleteHosRecordCDSS': '/api/cdssman/hospitalInfo/deleteRecord',   //医院信息——删除映射关系
    'getHospitalInfoCDSS': '/api/cdssman/hospitalInfo/getHospitalInfo',   //医院信息——获取医院信息
    'getUserRoleCDSS': '/api/cdssman/userRole/getUserRole',   //医院管理员列表
    'cancelUserRoleCDSS': '/api/cdssman/userRole/cancelUserRole',   //删除医院管理员
    'addUserRoleCDSS': '/api/cdssman/userRole/addUserRole',   //添加医院管理员

    'cancelPlanDatasCDSS': '/api/cdssman/plan/cancelPlanDatas',   //删除方案配置信息
    'getPlanInfoIdsCDSS': '/api/cdssman/plan/getPlanInfoIds',   //根据方案id获取配置信息
    'getPlanInfoPagesCDSS': '/api/cdssman/plan/getPlanInfoPages',   //分页获取方案配置信息
    'getDefaultPlansCDSS': '/api/cdssman/plan/getPlansDefault',   //获取默认方案配置
    'getSysPlanInfoDatasCDSS': '/api/cdssman/plan/getSysPlanInfoDatas',   //根据医院获取方案配置信息
    'revStopPlansCDSS': '/api/cdssman/plan/revStopPlans',   //停用启用方案配置
    'savePlanInfoDatasCDSS': '/api/cdssman/plan/savePlanInfoDatas',   //保存更新方案配置信息

    'getEntityPageCDSS': '/entityman/getEntityPage',   //知识图谱分页
    'isEntitymanExistCDSS': '/entityman/isExist',   //知识图谱-唯一校验
    'saveEntity': '/entityman/saveEntity',   //知识图谱
    'getEntitymanById': '/entityman/getById',   //查看实体对象
    'dataEntityVerify': '/entityman/dataVerify',   //术语关联校验（静态知识、术语关联、开单合理性规则）


    'BatchUpdateHasInfoStatus': '/staticKnowledge/BatchUpdateHasInfoStatus',   //术语关联校验（静态知识、术语关联、开单合理性规则）

    'getVersionInfoAllsCDSS': '/api/cdssman/versionInfo/getVersionInfoAlls',   //获取版本信息
    'saveVersionInfoAllsCDSS': '/api/cdssman/versionInfo/saveVersionInfoAlls',   //保存版本信息
    'cancelVersionInfoAllsCDSS': '/api/cdssman/versionInfo/cancelVersionInfoAlls',   //删除版本信息
    'updateVersionInfoAllsCDSS': '/api/cdssman/versionInfo/updateVersionInfoAlls',   //更新版本信息
    'addVersionDetailsCDSS': '/api/cdssman/versionDetail/addVersionDetails',   //增加版本详情信息
    'cancelVersionDetailsCDSS': '/api/cdssman/versionDetail/cancelVersionDetails',   //删除版本详情信息
    'getDetailByIdCDSS': '/api/cdssman/versionDetail/getDetailById',   //根据版本id获取版本详情信息
    'updateVersionDetailsCDSS': '/api/cdssman/versionDetail/updateVersionDetails',   //更新版本详情信息

    'addDisclaimerInfosCDSS': '/api/cdssman/disclaimerInfo/addDisclaimerInfos',   //增加免责申明详情
    'cancelDisclaimerInformationsCDSS': '/api/cdssman/disclaimerInfo/cancelDisclaimerInformations',   //删除免责申明详情
    'endDisclaimerInformationsCDSS': '/api/cdssman/disclaimerInfo/endDisclaimerInformations',   //停用免责申明详情
    'getDisclaimerPagesCDSS': '/api/cdssman/disclaimerInfo/getDisclaimerPages',   //分页查询获取免责申明
    'startDisclaimerInformationsCDSS': '/api/cdssman/disclaimerInfo/startDisclaimerInformations',   //启用免责申明详情
    'updateDisclaimerInformationsCDSS': '/api/cdssman/disclaimerInfo/updateDisclaimerInformations',   //修改免责申明详情

    'getListDicCDSS': '/api/cdssman/sys/dictionaryInfo/getList',   //返回字典信息(界面返回)
    'getListBack': '/api/cdssman/sys/dictionaryInfo/getListBack',   //返回字典信息(后台返回)

    'getKlmEnumsDataCDSS': '/api/cdssman/getKlmEnumsData',   //枚举数据获取


    'getCaseResultList': '/api/cdssman/test/rule/getCaseResultList',
    'billRuleTest': '/api/cdssman/test/rule/billRuleTest',
    'getResultBillPage': '/api/cdssman/test/rule/getResultBillPage',
    'exportRuleExcel': '/api/cdssman/test/rule/exportExcel',
    'ruleAllTest': '/api/cdssman/test/rule/ruleTest',
    'getResultCriticalPage': '/api/cdssman/test/rule/getResultCriticalPage',   //危急值测试列表
    'criticalRuleTest': '/api/cdssman/test/rule/criticalRuleTest',   //危急值规则测试
    'getResultHighriskDrugPage': '/api/cdssman/test/rule/getResultHighriskDrugPage',   //高危药品测试列表
    'highRiskRuleTest': '/api/cdssman/test/rule/highRiskRuleTest',   //高危药品、手术规则测试
    'getResultHighriskOperationPage': '/api/cdssman/test/rule/getResultHighriskOperationPage',   //高危手术测试列表
    'getResultOtherLisPage': '/api/cdssman/test/rule/getResultOtherLisPage',   //其他值提醒（化验）测试列表
    'getResultOtherPacsPage': '/api/cdssman/test/rule/getResultOtherPacsPage',   //其他值提醒（辅检）测试列表
    'getResultOtherTransfusionPage': '/api/cdssman/test/rule/getResultOtherTransfusionPage',   //其他值提醒（输血）测试列表
    'otherRuleTest': '/api/cdssman/test/rule/otherRuleTest',   //其他值提醒规则测试

    'billExportExcel': '/api/cdssman/test/rule/billExportExcel',   //开单合理性规则测试结果导出
    'criticalExportExcel': '/api/cdssman/test/rule/criticalExportExcel',   //危急值规则测试结果导出
    'highriskDrugExportExcel': '/api/cdssman/test/rule/highriskDrugExportExcel',   //高危药品规则测试结果导出
    'highriskOperationExportExcel': '/api/cdssman/test/rule/highriskOperationExportExcel',   //高危手术规则测试结果导出
    'otherLisExportExcel': '/api/cdssman/test/rule/otherLisExportExcel',   //化验其他提醒规则测试结果导出
    'otherPacsExportExcel': '/api/cdssman/test/rule/otherPacsExportExcel',   //辅检其他提醒规则测试结果导出
    'otherTransfusionExportExcel': '/api/cdssman/test/rule/otherTransfusionExportExcel',   //输血其他提醒规则测试结果导出

    'exportStaticCommonExcel': '/api/cdssman/test/staticKnowledge/exportCommonExcel',   //通用未映射到标准术语测试结果导出
    'exportStaticCommonStaticExcel': '/api/cdssman/test/staticKnowledge/exportCommonStaticExcel',   //通用缺少静态知识测试结果导出
    'exportStaticLisExcel': '/api/cdssman/test/staticKnowledge/exportLisExcel',   //检验未映射到标准术语测试结果导出
    'exportStaticLisStaticExcel': '/api/cdssman/test/staticKnowledge/exportLisStaticExcel',   //检验缺少静态知识测试结果导出
    'getStaticCaseResultList': '/api/cdssman/test/staticKnowledge/getCaseResultList',   //静态知识测试总览列表
    'getStaticPage': '/api/cdssman/test/staticKnowledge/getPage',   //静态知识测试结果明细列表
    'staticKnowledgeTest': '/api/cdssman/test/staticKnowledge/staticKnowledgeTest',   //静态知识测试
    'getRunningStatus': '/api/cdssman/test/running/getStatus',   //查看测试用例运行状态
    'getRunningStatusByHospitalId': '/api/cdssman/test/running/getStatusByHospitalId',   //查拉面所有测试用例运行状态
    'updateRunningStatus': '/api/cdssman/test/running/updateStatus',   //更新测试用例运行状态
    //知识库规则维护
    'zskRuleList': '/api/cdssman/klRule/getKlRuleInfoPage',//规则列表
    'zskAddRule': '/api/cdssman//klRule/saveRuleInfo',//添加规则
    'zskActiveRule': '/api/cdssman/klRule/startRuleInfo',//启用规则
    'zskDisableRule': '/api/cdssman/klRule/disableRuleInfo',//禁用规则
    'zskDelRule': '/api/cdssman/klRule/clearRuleInfo',//删除规则
    'zskRuleDetail': '/api/cdssman/klRule/getByIdRuleInfo',//规则详情
    'zskTypeList': '/api/cdssman/klRulePlan/getMenu',//类型列表
    'zskSearchConcept': '/api/cdssman/klDisease/searchConcept',//知识库搜索术语
    'zskUpdateAll': '/api/cdssman/cache/clearRuleAll',//更新数据
    'zskgetDict': '/api/cdssman/kl/dictionary/getDictionarys',//
    //知识库树形图
    'getTree': '/api/cdssman/multContact/getTree',//获取当前type数据
    'searchTreeItem': '/api/cdssman/multContact/getAllForRelation',//检索树元素
    'addTreeRelation': '/api/cdssman/multContact/addRelation',//保存树元素
    //知识库基础维护
    'getBaseConceptInfoPage': '/api/cdssman/graph/klConcept/getConceptInfoPage',
    'startConcept': '/api/cdssman/graph/klConcept/startConcept',
    'disableConcept': '/api/cdssman/graph/klConcept/disableConcept',
    'baseTypeGetPage': '/api/cdssman/kl/lexicon/getPage',
    'baseRelationTypeGetPage': '/api/cdssman/kl/lexiconRelationship/getPage',
    'clearStandRuleDrug': '/api/cdssman/cache/clearStandRuleDrug',
    'saveBaseConceptInfo': '/api/cdssman/graph/klConcept/saveConceptInfo',
    'getBaseConceptAll': '/api/cdssman/graph/klConcept/getConceptAll',
    'clearConceptInfo': '/api/cdssman/graph/klConcept/clearConceptInfo',
    //疾病相关维护
    'getDiseasePage': '/api/cdssman/klDisease/getDiseasePage',
    'diseaseDelete': '/api/cdssman/klDisease/delete',
    'getBaseDetail': '/api/cdssman/klDisease/getDetail',
    'searchConcept': '/api/cdssman/klDisease/searchConcept',
    'findDisName': '/api/cdssman/klDisease/findDisName',
    'diseaseBaseSave': '/api/cdssman/klDisease/save',
    //静态知识术语
    'staticBaseKnowledge': '/api/cdssman/kl/conceptInfo/getPage',
    'changeBaseStatus': '/api/cdssman/kl/conceptInfo/changeStatus',
    'getBaseRecordById': '/api/cdssman/kl/conceptInfo/getRecordById',
    'saveBaseOrUpdateRecord': '/api/cdssman/kl/conceptInfo/saveOrUpdateRecord',
    'staticKnowledgeBaseInfo': '/api/cdssman/kl/conceptInfo/staticKnowledgeIndexWithoutInfo',
    //规则测试相关
    'allRuleTest': '/api/cdssman/test/rule/allRuleTest',
    'autoGetCaseResultList': '/api/cdssman/test/rule/getCaseResultList',
    'getDroplistData': '/api/cdssman/test/rule/getDroplistData',
    'getResultRulePage': '/api/cdssman/test/rule/getResultRulePage',
    'ruleExportExcel': '/api/cdssman/test/rule/ruleExportExcel',
    'autoRuleTest': '/api/cdssman/test/rule/ruleTest',
    'clearDrug': '/api/cdssman/cache/clearDrug',
  },
  menuIconList: { //菜单对应图标
    'YH-KZT': 'el-icon-menu',
    'YH-GDFW': 'el-icon-service',
    'YH-JGZX': 'el-icon-goods',
    'LT-KHZX': 'el-icon-document',
    'LT-KZT': 'el-icon-edit-outline',
    'LT-DDXT': 'el-icon-setting',
    'LT-CPXGL': 'el-icon-upload',
    'LT-GRZX': 'el-icon-news'
  },
  labelTypesMaps: {       //// 归属和填写单类型限制
    '1': ['2', '3', '4', '11'],
    '3': ['2', '4', '6'],
    '4': ['2', '3'],
    '5': ['7'],
    '6': ['9'],
    '7': ['9'],
    '8': ['9']
  },
  groupParams: [
    { controlType: [0, 1, 2], tagType: [1] },     //多列多选（杂音/初为）     notTagType为文字标签剔除
    { controlType: [0, 1, 2, 5, 6, 7, 8], tagType: [1] },  //多项统一横铺标签（血压）
    { controlType: [0, 1, 2, 5, 6, 7, 8, 11], tagType: [1, 2, 3] },  //症状详细（症状尾巴）
    { controlType: [0, 1, 2], tagType: [1, 4] }, //组合项标签（既往史）
    { controlType: [0, 1, 6], tagType: [1] },    //化验组合
    { controlType: [0, 1, 2, 99], tagType: [1] },   //症状推送类型（添加症状）
  ],
  msg: {
    imgTip: '无法上传图片，图片大小不可超过2M'
  },
  pageSizeArr: [10, 50, 100, 500, 1000, 5000],         //分页每页显示条数选项
  pageSize: 10,      //初始每页显示条数
  pageLayout: "total,sizes,prev, pager, next, jumper",        //分页组件成分
  drugForm: [
    // { "name": "","val": "0"},
    { "name": "注射剂", "val": "1" },
    { "name": "片剂", "val": "2" },
    { "name": "缓释片", "val": "3" },
    { "name": "胶囊剂", "val": "4" },
    { "name": "滴丸剂", "val": "5" },
  ],
  contentTypes: [
    {
      "name": "静态信息",
      "key": 1
    },
    {
      "name": "注意事项",
      "key": 2
    },
    {
      "name": "临床路径",
      "key": 3
    },
    {
      "name": "一般治疗",
      "key": 4
    },

  ],
  emData: [
    {
      "name": "诊断",
      "key": 1
    },
    {
      "name": "检验套餐",
      "key": 3
    },
    {
      "name": "检验细项",
      "key": 4
    },
    {
      "name": "检查",
      "key": 5
    },
    {
      "name": "药品",
      "key": 2
    },

    {
      "name": "检查子项",
      "key": 6
    },
    {
      "name": "手术和操作",
      "key": 7
    },
    // {
    //     "name":"科室",
    //     "key":18
    // },
  ],
}
